spool /oradata06/prdred/logs/calculate_statistics.log

set serveroutput on
set timing on
set echo on
select to_char(sysdate, 'HH:MI AM') from dual;

declare

v_count number;

cursor c1 is
select owner, index_name from dba_indexes
where owner = 'STAGE'
ORDER BY INDEX_NAME;

cursor c2 is 
select owner, index_name from dba_indexes
where owner = 'STAGE'
and status = 'UNUSABLE'
ORDER BY INDEX_NAME;

begin

for x in c1 loop

   execute immediate 'ALTER INDEX '||X.OWNER||'.'||X.INDEX_NAME||' REBUILD';

end loop;

select count(*)
into v_count
from dba_indexes
where owner = 'STAGE'
and status = 'UNUSABLE';

if v_count > 0 then

   for y in c2 loop
      
      execute immediate 'ALTER INDEX '||Y.OWNER||'.'||Y.INDEX_NAME||' REBUILD';
   
   end loop;

end if;

exception
when others then
dbms_output.put_line(sqlcode||' '||sqlerrm);
end;
/

select to_char(sysdate, 'HH:MI AM') from dual;

exec dbms_stats.gather_schema_stats(ownname => 'STAGE', cascade => TRUE);

select to_char(sysdate, 'HH:MI AM') from dual;

SPOOL OFF
set timing off
set echo off
exit                                    
